/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
insn_current_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_variable_length_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_min_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 34:  /* movsf_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return 3;
        }
      else if (((1ULL << which_alternative) & 0x38ULL))
        {
	  return 2;
        }
      else if (((1ULL << which_alternative) & 0x3c0ULL))
        {
	  return 3;
        }
      else if (which_alternative == 10)
        {
	  return 6;
        }
      else
        {
	  return 3;
        }

    case 31:  /* movsi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3fULL))
        {
	  return 2;
        }
      else if (((1ULL << which_alternative) & 0x3c0ULL))
        {
	  return 3;
        }
      else if (which_alternative == 10)
        {
	  return 6;
        }
      else
        {
	  return 3;
        }

    case 33:  /* movqi_internal */
    case 32:  /* movhi_internal */
    case 1:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 80:  /* sync_compare_and_swapsi */
    case 44:  /* rotrsi3 */
    case 43:  /* rotlsi3 */
    case 42:  /* *lshrsi3_3x */
    case 40:  /* *ashrsi3_3x */
    case 38:  /* *ashlsi3_3x */
      return 6;

    case 72:  /* *unspec_nop */
    case 69:  /* *frame_blockage */
    case 68:  /* blockage */
    case 55:  /* loop_end */
    case 54:  /* zero_cost_loop_end */
      return 0;

    case 64:  /* return */
    case 36:  /* *ashlsi3_1 */
      return 2;

    case 41:  /* lshrsi3 */
    case 39:  /* ashrsi3 */
    case 37:  /* ashlsi3_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 3;
        }
      else
        {
	  return 6;
        }

    case 19:  /* bswapdi2 */
      return 27 /* 0x1b */;

    case 18:  /* bswapsi2 */
      return 15 /* 0xf */;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 67:  /* eh_set_a0_call0 */
    case 66:  /* eh_set_a0_windowed */
    case 35:  /* movdf_internal */
    case 30:  /* movdi_internal */
      return 1;

    default:
      return 3;

    }
}

int
insn_default_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 34:  /* movsf_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return 3;
        }
      else if (((1ULL << which_alternative) & 0x38ULL))
        {
	  return 2;
        }
      else if (((1ULL << which_alternative) & 0x3c0ULL))
        {
	  return 3;
        }
      else if (which_alternative == 10)
        {
	  return 6;
        }
      else
        {
	  return 3;
        }

    case 31:  /* movsi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3fULL))
        {
	  return 2;
        }
      else if (((1ULL << which_alternative) & 0x3c0ULL))
        {
	  return 3;
        }
      else if (which_alternative == 10)
        {
	  return 6;
        }
      else
        {
	  return 3;
        }

    case 33:  /* movqi_internal */
    case 32:  /* movhi_internal */
    case 1:  /* addsi3 */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x3ULL))
        {
	  return 2;
        }
      else
        {
	  return 3;
        }

    case 80:  /* sync_compare_and_swapsi */
    case 44:  /* rotrsi3 */
    case 43:  /* rotlsi3 */
    case 42:  /* *lshrsi3_3x */
    case 40:  /* *ashrsi3_3x */
    case 38:  /* *ashlsi3_3x */
      return 6;

    case 72:  /* *unspec_nop */
    case 69:  /* *frame_blockage */
    case 68:  /* blockage */
    case 55:  /* loop_end */
    case 54:  /* zero_cost_loop_end */
      return 0;

    case 64:  /* return */
    case 36:  /* *ashlsi3_1 */
      return 2;

    case 41:  /* lshrsi3 */
    case 39:  /* ashrsi3 */
    case 37:  /* ashlsi3_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 3;
        }
      else
        {
	  return 6;
        }

    case 19:  /* bswapdi2 */
      return 27 /* 0x1b */;

    case 18:  /* bswapsi2 */
      return 15 /* 0xf */;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 67:  /* eh_set_a0_call0 */
    case 66:  /* eh_set_a0_windowed */
    case 35:  /* movdf_internal */
    case 30:  /* movdi_internal */
      return 1;

    default:
      return 3;

    }
}

int
bypass_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
num_delay_slots (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

enum attr_mode
get_attr_mode (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 34:  /* movsf_internal */
    case 57:  /* movsfcc_internal0 */
      return MODE_SF;

    case 19:  /* bswapdi2 */
      return MODE_DI;

    case 32:  /* movhi_internal */
      return MODE_HI;

    case 33:  /* movqi_internal */
      return MODE_QI;

    case 45:  /* *btrue */
    case 46:  /* *bfalse */
    case 47:  /* *ubtrue */
    case 48:  /* *ubfalse */
    case 49:  /* *bittrue */
    case 50:  /* *bitfalse */
    case 51:  /* *masktrue */
    case 52:  /* *maskfalse */
    case 53:  /* zero_cost_loop_start */
    case 54:  /* zero_cost_loop_end */
    case 55:  /* loop_end */
    case 58:  /* jump */
    case 59:  /* indirect_jump_internal */
    case 60:  /* tablejump_internal */
    case 61:  /* call_internal */
    case 62:  /* call_value_internal */
    case 64:  /* return */
    case 65:  /* nop */
    case 70:  /* trap */
    case 72:  /* *unspec_nop */
    case 77:  /* tls_call */
    case 78:  /* *memory_barrier */
      return MODE_NONE;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 30:  /* movdi_internal */
    case 35:  /* movdf_internal */
    case 66:  /* eh_set_a0_windowed */
    case 67:  /* eh_set_a0_call0 */
    case 68:  /* blockage */
    case 69:  /* *frame_blockage */
      return MODE_UNKNOWN;

    default:
      return MODE_SI;

    }
}

enum attr_type
get_attr_type (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 34:  /* movsf_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_FARITH;
        }
      else if (which_alternative == 1)
        {
	  return TYPE_FLOAD;
        }
      else if (which_alternative == 2)
        {
	  return TYPE_FSTORE;
        }
      else if (which_alternative == 3)
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 4)
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 5)
        {
	  return TYPE_STORE;
        }
      else if (which_alternative == 6)
        {
	  return TYPE_MOVE;
        }
      else if (((1ULL << which_alternative) & 0x180ULL))
        {
	  return TYPE_FARITH;
        }
      else if (((1ULL << which_alternative) & 0x600ULL))
        {
	  return TYPE_MOVE;
        }
      else if (((1ULL << which_alternative) & 0x1800ULL))
        {
	  return TYPE_LOAD;
        }
      else
        {
	  return TYPE_STORE;
        }

    case 33:  /* movqi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0xfULL))
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 4)
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 5)
        {
	  return TYPE_STORE;
        }
      else if (which_alternative == 6)
        {
	  return TYPE_RSR;
        }
      else
        {
	  return TYPE_WSR;
        }

    case 32:  /* movhi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x1fULL))
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 5)
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 6)
        {
	  return TYPE_STORE;
        }
      else if (which_alternative == 7)
        {
	  return TYPE_RSR;
        }
      else
        {
	  return TYPE_WSR;
        }

    case 31:  /* movsi_internal */
      extract_constrain_insn_cached (insn);
      if (((1ULL << which_alternative) & 0x7ULL))
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 3)
        {
	  return TYPE_LOAD;
        }
      else if (((1ULL << which_alternative) & 0x30ULL))
        {
	  return TYPE_STORE;
        }
      else if (((1ULL << which_alternative) & 0x7c0ULL))
        {
	  return TYPE_MOVE;
        }
      else if (((1ULL << which_alternative) & 0x1800ULL))
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 13)
        {
	  return TYPE_STORE;
        }
      else if (which_alternative == 14)
        {
	  return TYPE_RSR;
        }
      else
        {
	  return TYPE_WSR;
        }

    case 6:  /* mulhisi3 */
    case 7:  /* umulhisi3 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_MUL16;
        }
      else
        {
	  return TYPE_MAC16;
        }

    case 24:  /* zero_extendhisi2 */
    case 25:  /* zero_extendqisi2 */
    case 26:  /* extendhisi2_internal */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_ARITH;
        }
      else
        {
	  return TYPE_LOAD;
        }

    case 70:  /* trap */
      return TYPE_TRAP;

    case 63:  /* entry */
      return TYPE_ENTRY;

    case 74:  /* set_thread_pointersi */
      return TYPE_WSR;

    case 73:  /* get_thread_pointersi */
      return TYPE_RSR;

    case 8:  /* divsi3 */
    case 9:  /* udivsi3 */
    case 10:  /* modsi3 */
    case 11:  /* umodsi3 */
      return TYPE_DIV32;

    case 5:  /* mulsi3 */
      return TYPE_MUL32;

    case 65:  /* nop */
    case 68:  /* blockage */
    case 72:  /* *unspec_nop */
      return TYPE_NOP;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    case 43:  /* rotlsi3 */
    case 44:  /* rotrsi3 */
    case 80:  /* sync_compare_and_swapsi */
      return TYPE_MULTI;

    case 56:  /* movsicc_internal0 */
    case 57:  /* movsfcc_internal0 */
    case 71:  /* set_frame_ptr */
      return TYPE_MOVE;

    case 79:  /* sync_lock_releasesi */
      return TYPE_STORE;

    case 75:  /* tls_func */
    case 76:  /* tls_arg */
      return TYPE_LOAD;

    case 61:  /* call_internal */
    case 62:  /* call_value_internal */
    case 77:  /* tls_call */
      return TYPE_CALL;

    case 45:  /* *btrue */
    case 46:  /* *bfalse */
    case 47:  /* *ubtrue */
    case 48:  /* *ubfalse */
    case 49:  /* *bittrue */
    case 50:  /* *bitfalse */
    case 51:  /* *masktrue */
    case 52:  /* *maskfalse */
    case 53:  /* zero_cost_loop_start */
    case 54:  /* zero_cost_loop_end */
    case 55:  /* loop_end */
    case 58:  /* jump */
    case 59:  /* indirect_jump_internal */
    case 60:  /* tablejump_internal */
    case 64:  /* return */
      return TYPE_JUMP;

    case 30:  /* movdi_internal */
    case 35:  /* movdf_internal */
    case 66:  /* eh_set_a0_windowed */
    case 67:  /* eh_set_a0_call0 */
    case 69:  /* *frame_blockage */
    case 78:  /* *memory_barrier */
      return TYPE_UNKNOWN;

    default:
      return TYPE_ARITH;

    }
}

int
eligible_for_delay (rtx_insn *delay_insn ATTRIBUTE_UNUSED, int slot, 
		   rtx_insn *candidate_insn, int flags ATTRIBUTE_UNUSED)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;

  if (num_delay_slots (delay_insn) == 0)
    return 0;
  gcc_assert (slot < 0);

  if (!INSN_P (candidate_insn))
    return 0;

  insn = candidate_insn;
  switch (slot)
    {
    default:
      gcc_unreachable ();
    }
}

int
eligible_for_annul_true (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
eligible_for_annul_false (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
const_num_delay_slots (rtx_insn *insn)
{
  switch (recog_memoized (insn))
    {
    default:
      return 1;
    }
}

EXPORTED_CONST int length_unit_log = 0;
